REBOL [
  Title: "BBC News -- Headline Extractor -> HTML"
  Date:  28-September-1999
  File:  %bbc_html.r
  Purpose: {
      Download the BBC News page and form a digest file
      of the headlines in HTML.
      Also sorts the news items into UK and World.
  }
]

; Allow REBOL to write to the file without constant prompting
; (Run REBOL with -s option to avoid the prompt from this command, too)
secure none

out: %digest.html
write out "<HTML>^/<BODY>^/"
world: make string! 1000
uk: make string! 1000
text: read http://news.bbc.co.uk/
; Save a local copy to help with development...
write %news.html text
line: ["<TD" thru ">" any [newline | "<FONT" thru ">" | <B>]
        ["<A" any newline {HREF="/hi/english/} copy type to "/" copy ref to {">} {">}
          [ "<IMG" (item: "")
          | "<FONT" thru ">" copy item to </FONT>
          | copy item to "</A>"]
          (if not empty? item
            [either (type = "world") [str: world] [str: uk]
             append str rejoin
               [{<A HREF="/hi/english/} type "/" ref {">} trim/lines item "</A><BR>^/"]])
        | none]
       thru </TD>] 
parse text
  [thru <!--******** "Todays date" component ******** -->
   some [line | newline | thru <TR> | thru </HTML>]
  ]

write/append out "<H1>UK</H1>^/"
write/append out uk
write/append out "<H1>World</H1>^/"
write/append out world
write/append out "</BODY>^/</HTML>^/"
